; #########################################################################
;                                                                         ;
;    ()   -  XP                 ;                           ;
;  
;hDC:HDC         -       ()
;lpRect:DWORD    -     ()
;AlignWidth:BYTE -      
;                 ()  ,   
;                DARK_LEFT   -  -  ( )
;                DARK_RIGHT  -  -  ( )
;                DARK_NONE   -    .
;AlignHeight:BYTE -      
;                 ()  ,   
;                DARK_UP     -  -  ( )
;                DARK_DOWN   -  -  ( )
;                DARK_NONE   -    .
;nHorizDark:BYTE -     (~ 0 -  (max)). !?!
;nVertDark:BYTE  -     (~ 0 -  (max)). !?!
;
; #########################################################################

DrawShade proc uses ebx hDC :HDC, lpRect:DWORD, AlignWidth :BYTE, AlignHeight :BYTE, 
                             nHorizDark :BYTE, nVertDark :BYTE

    LOCAL X1, Y1            :DWORD
    LOCAL nWidth, nHeight   :DWORD
    LOCAL cnWidth, cnHeight   :DWORD
    LOCAL tClr              :COLORREF
        
        
        mov ebx, lpRect
        
        m2m nWidth, [ebx].RECT.right
        mov eax, [ebx].RECT.left
        sub nWidth, eax                 ;  
        m2m cnWidth, nWidth 
        
        m2m nHeight, [ebx].RECT.bottom
        mov eax, [ebx].RECT.top
        sub nHeight, eax                ;  
        m2m cnHeight, nHeight
        
  
        .while nHeight
 
            m2m Y1, [ebx].RECT.bottom
            mov eax, nHeight 
            sub Y1, eax
  
            push nWidth
            .while nWidth
            
                m2m X1, [ebx].RECT.right
                mov eax, nWidth
                sub X1, eax
                mov tClr, $invoke ( GetPixel, hDC, X1, Y1 )
                ;    
                .if AlignWidth == DARK_LEFT                         ;  -  ( )
                    mov eax, nWidth
                .elseif AlignWidth == DARK_RIGHT                    ;  -  ( )
                    mov eax, cnWidth
                    sub eax, nWidth                    
                .elseif AlignWidth == DARK_NONE                     ;    
                    jmp @f               
                .endif                
                
                invoke IntMul, eax, DWORD PTR nHorizDark    ;     (~ 0 - 15 (max)).
                invoke DarkenColor, eax, tClr
                mov tClr, eax
                
@@:
                ;    
                .if AlignHeight == DARK_UP                          ;  -  ( )
                    mov eax, nHeight                    
                .elseif AlignHeight == DARK_DOWN                    ;  -  ( )
                    mov eax, cnHeight 
                    sub eax, nHeight
                .elseif AlignHeight == DARK_NONE                    ;    
                    jmp @f    
                .endif                
                
                invoke IntMul, eax, DWORD PTR nVertDark     ;     (~ 0 - 15 (max)).
                invoke DarkenColor, eax, tClr            
                mov tClr, eax
@@:
            
                invoke SetPixel, hDC, X1, Y1, tClr
                         
                dec nWidth
            
            .endw
            pop nWidth
  
         dec nHeight        
        .endw  
  
    ret
DrawShade endp