; #########################################################################
;                                                                         ;
;   WM_DRAWITEM ( XP)                              ;
;                                                                         ;
; #########################################################################

DrawItemXP proc uses ecx ;edx lParam:LPARAM

    LOCAL mii         :MENUITEMINFO
    LOCAl TextItemLen :DWORD
    LOCAL szBuff[128] :BYTE
    LOCAL hIcon       :HICON
    LOCAL temp        :DWORD
    LOCAL tSelect     :BYTE         ;        .
    LOCAL RctText     :RECT
    LOCAL RctBorder   :RECT
    LOCAL RctSep      :RECT
    LOCAL RctShade    :RECT
    LOCAL RctCorner   :RECT

    LOCAL hBrushSel   :HBRUSH
    LOCAL hBrushSelBor:HBRUSH
    LOCAL hBrushSep   :HBRUSH  ;        CheckItema
    LOCAL hBrushRight :HBRUSH  ;    ,    .
    LOCAL hBrushBorder:HBRUSH
    LOCAL hBrushUpItem:HBRUSH    
    
    LOCAL colorText   :COLORREF
    LOCAL colorWindow :COLORREF
    LOCAL colorMenu   :COLORREF
    LOCAL colorMenuBar:COLORREF
    LOCAL colorBorder :COLORREF
    LOCAL colorBitmap :COLORREF
    LOCAL colorSel    :COLORREF
    LOCAL colorSep    :COLORREF
    
    LOCAL fDrawState  :BYTE

    ; ,   ..      

    mov colorBorder, $invoke ( GetSysColor, COLOR_HIGHLIGHT )
    mov colorMenuBar, $invoke ( GetSysColor, COLOR_MENU )
    mov colorWindow, $invoke ( GetSysColor, COLOR_WINDOW )
    mov colorBitmap, $invoke ( MixedColor, colorMenuBar, colorWindow )
    mov colorSep, $invoke ( GetSysColor, COLOR_GRAYTEXT )   
    call GetXpHighlightColor
    mov colorSel, eax

;      

    invoke MixedColor, colorSel, colorBorder
    invoke CreateSolidBrush, eax
    mov hBrushUpItem, eax

;         

    invoke MixedColor, colorSel, colorBorder
    invoke LightenColor, 64, eax
    invoke CreateSolidBrush, eax
    mov hBrushSel, eax

    invoke MixedColor, colorSel, colorBorder
    invoke DarkenColor, 128, eax
    invoke CreateSolidBrush, eax
    mov hBrushSelBor, eax

;         ( - )

    invoke GrayColor, colorWindow
    mov edx, 255
    sub edx, eax
    
    .if eax > 215
        invoke MixedColor, colorWindow, colorMenuBar        
    .else   
        invoke LightenColor, edx, colorWindow   
    .endif  
    
    invoke CreateSolidBrush, eax
    mov hBrushRight, eax    

    ;          
    
    invoke GrayColor, colorMenuBar
    mov edx, 255
    sub edx, eax
    
    .if eax > 215
        invoke MixedColor, colorMenuBar, colorBorder            
    .else   
        invoke LightenColor, edx, colorMenuBar  
    .endif  
    
    invoke CreateSolidBrush, eax
    mov hBrushBorder, eax
  
;  

    invoke DarkenColor, 8, colorSep
    invoke CreateSolidBrush, colorSep
    mov hBrushSep, eax

; ======================================================================

assume ebx: ptr DRAWITEMSTRUCT

;         
    mov mii.cbSize, SIZEOF mii
    mov mii.fMask, MIIM_DATA or MIIM_BITMAP or MIIM_FTYPE ;or MIIM_STRING
    invoke GetMenuItemInfo, [ebx].hwndItem, [ebx].itemID, FALSE, ADDR mii
    m2m hIcon, mii.dwItemData
    
    mov eax, mii.fType
    and eax, MFT_SEPARATOR or MFT_STRING or MFT_BITMAP    

    .if eax == MFT_STRING                  ;   STRING
    
        invoke GetMenuString, [ebx].hwndItem, [ebx].itemID, ADDR szBuff, 128, MF_BYCOMMAND ;  
        mov TextItemLen, eax

        .if fPopup              ; popup

   
            ;     (٨?)
        
            .if [ebx].itemState & ODS_GRAYED
                invoke GetSysColor, COLOR_GRAYTEXT
                .if fSelection                      ;     .
                    mov tSelect, TRUE
                .else
                    mov tSelect, FALSE
                .endif
            .else
                invoke GetSysColor, COLOR_MENUTEXT
                mov tSelect, TRUE
            .endif
            invoke SetTextColor, [ebx].hdc, eax
        
            .if [ebx].itemState & ODS_SELECTED
                cmp tSelect, 0
                je @f      
                        
                invoke FillRect, [ebx].hdc, ADDR [ebx].rcItem, hBrushSel
                invoke FrameRect, [ebx].hdc, ADDR [ebx].rcItem, hBrushSelBor
                mov fDrawState, SELECT
                                        
@@:
            .else    
                invoke FillRect, [ebx].hdc, ADDR [ebx].rcItem, hBrushBorder   
                
                ;        
        
                invoke CopyRect, ADDR RctBorder, ADDR [ebx].rcItem
                mov eax, WidthBorder
                add RctBorder.left, eax                 
                invoke FillRect, [ebx].hdc, ADDR RctBorder, hBrushRight
                mov fDrawState, UNSELECT
            .endif
              
           .if [ebx].itemState & ODS_GRAYED
                mov fDrawState, GRAY
           .endif
            
           .if [ebx].itemState & ODS_CHECKED    ;           
               
                .if hIcon
                
                    .if fDrawState == SELECT
                        mov fDrawState, UNSELECT
                    .endif                
                
                    dec [ebx].rcItem.top                
                    invoke DrawIcn, [ebx].hdc, ADDR [ebx].rcItem, hIcon, fDrawState
                    inc [ebx].rcItem.top                    
                    
                .else
               
                    ;              
                    ;              
                    mov eax, mii.fType
                    and eax, MFT_RADIOCHECK
                    .if eax == MFT_RADIOCHECK
                        mov al, TRUE
                    .else
                        mov al, FALSE
                    .endif
                    invoke DrawCheck_XP, [ebx].hdc, ADDR [ebx].rcItem, fDrawState, al
        
                .endif
        
           .else
           
                .if hIcon
                    invoke DrawIcn, [ebx].hdc, ADDR [ebx].rcItem, hIcon, fDrawState    ; DRAW ICON
                .elseif mii.hbmpItem                    
                    invoke DrawBmp, [ebx].hdc, ADDR [ebx].rcItem, mii.hbmpItem, fDrawState                    
                .endif
                    
           .endif
        
            ; 
            ;
        
        ;   
            invoke CopyRect, ADDR RctText, ADDR [ebx].rcItem
            mov eax, WidthBorder
            add RctText.left, eax
            add RctText.left,4        ;         
            sub RctText.right, 10     ;        Tab
                
        ;     
            push TextItemLen
        
            cld                         ;    
            lea edi, szBuff             ;  
            mov al, 09h                 ;  
            mov ecx, TextItemLen        ;  
            repne scasb                 ;   '\t'  
            jne no_tab                  ;  '\t'        
            
            push ecx
            invoke DrawText, [ebx].hdc, edi, ecx, ADDR RctText, DT_VCENTER + DT_SINGLELINE + DT_RIGHT + DT_NOCLIP
            pop ecx
            sub TextItemLen, ecx
            dec TextItemLen
no_tab: 
            invoke DrawText, [ebx].hdc, ADDR szBuff, TextItemLen, ADDR RctText, DT_VCENTER + DT_SINGLELINE + DT_LEFT + DT_NOCLIP
        
            pop TextItemLen
            
        .else           ; main

            .if [ebx].itemState & ODS_HOTLIGHT          ; SELECT
                
                sub [ebx].rcItem.right, 4 ;  
                invoke FillRect,[ebx].hdc,ADDR [ebx].rcItem, hBrushUpItem
                invoke FrameRect, [ebx].hdc, ADDR [ebx].rcItem, hBrushSelBor
                add [ebx].rcItem.right, 4 ;                  
                jmp hotlight
              
            .endif
                     
            ;     (٨?)
        
            .if [ebx].itemState & ODS_GRAYED
                invoke GetSysColor, COLOR_GRAYTEXT
                .if fSelection                      ;     .
                    mov tSelect, TRUE
                .else
                    mov tSelect, FALSE
                .endif
            .else
                invoke GetSysColor, COLOR_MENUTEXT
                mov tSelect, TRUE
            .endif
            invoke SetTextColor, [ebx].hdc, eax
        
            .if [ebx].itemState & ODS_SELECTED
                cmp tSelect, 0
                je @f      
                
                inc [ebx].rcItem.bottom         
                invoke FillRect,[ebx].hdc,ADDR [ebx].rcItem,COLOR_BTNFACE+1
                dec [ebx].rcItem.bottom
                sub [ebx].rcItem.right, 4 ;  
                
                invoke GetSysColorBrush,COLOR_BTNSHADOW
                inc [ebx].rcItem.bottom
                invoke FrameRect, [ebx].hdc, ADDR [ebx].rcItem, eax
                dec [ebx].rcItem.bottom                
                
                ;                    
                m2m RctShade.left, [ebx].rcItem.right          
                add [ebx].rcItem.right, 4
                
                m2m RctShade.top, [ebx].rcItem.top
                m2m RctShade.bottom, [ebx].rcItem.bottom
                m2m RctShade.right, [ebx].rcItem.right          
          
                ;    4 * 4,   -  -                 
                invoke CopyRect, ADDR RctCorner, ADDR RctShade          
                add RctCorner.top, 4
                m2m RctCorner.bottom, RctCorner.top
                add RctCorner.bottom, 4          
                invoke DrawShade, [ebx].hdc, ADDR RctCorner, DARK_LEFT, DARK_DOWN, 6, 6
                
                invoke CopyRect, ADDR RctCorner, ADDR RctShade
                add RctCorner.top, 8  
                invoke DrawShade, [ebx].hdc, ADDR RctCorner, DARK_LEFT, DARK_NONE, 16, NULL               
                
                mov fDrawState, SELECT
                                        
@@:
            .else
            
;                invoke FillRect,[ebx].hdc,ADDR [ebx].rcItem,COLOR_BTNFACE+1
            
;                sub [ebx].rcItem.right, 4 ;      
                inc [ebx].rcItem.bottom             ;  
                invoke FillRect,[ebx].hdc,ADDR [ebx].rcItem,COLOR_BTNFACE+1 
                dec [ebx].rcItem.bottom
;                add [ebx].rcItem.right, 4               
                mov fDrawState, UNSELECT
            .endif

hotlight:
            
            invoke CopyRect, ADDR RctText, ADDR [ebx].rcItem   
              
           .if [ebx].itemState & ODS_GRAYED
                mov fDrawState, GRAY
           .endif
            
           .if [ebx].itemState & ODS_CHECKED    ;           
               
        ;        .if hIcon
        ;        
        ;            .if fDrawState == SELECT
        ;                mov fDrawState, UNSELECT
        ;            .endif 
        ;        
        ;            invoke DrawIcn, [ebx].hdc, ADDR [ebx].rcItem, hIcon, fDrawState
        ;        .else
               
                    ;              
                    ;              
                    mov eax, mii.fType
                    and eax, MFT_RADIOCHECK
                    .if eax == MFT_RADIOCHECK
                        mov al, TRUE
                    .else
                        mov al, FALSE
                    .endif
                    invoke DrawCheck_XP, [ebx].hdc, ADDR [ebx].rcItem, fDrawState, al
        
        ;        .endif
                 mov eax, WidthBorder
                 add RctText.left, eax
        
           .else
           
                .if hIcon
                    invoke DrawIcn, [ebx].hdc, ADDR [ebx].rcItem, hIcon, fDrawState    ; DRAW ICON
                    mov eax, WidthBorder
                    add RctText.left, eax
                .elseif mii.hbmpItem                    
                    invoke DrawBmp, [ebx].hdc, ADDR [ebx].rcItem, mii.hbmpItem, fDrawState
                    mov eax, WidthBorder
                    add RctText.left, eax                   
                .endif
                    
           .endif            

            ; 
            ;
            sub RctText.right, 4        ;  ,      
            ;     
            push TextItemLen
        
            cld                         ;    
            lea edi, szBuff             ;  
            mov al, 09h                 ;  
            mov ecx, TextItemLen        ;  
            repne scasb                 ;   '\t'  
            jne no_tab2                 ;  '\t'        
            
            push ecx
            
            ;add RctText.left, 4            
            
            invoke DrawText, [ebx].hdc, edi, ecx, ADDR RctText, DT_VCENTER + DT_SINGLELINE + DT_RIGHT + DT_NOCLIP
            pop ecx
            sub TextItemLen, ecx
            dec TextItemLen
            invoke DrawText, [ebx].hdc, ADDR szBuff, TextItemLen, ADDR RctText, DT_VCENTER + DT_SINGLELINE + DT_LEFT + DT_NOCLIP        
            pop TextItemLen
            jmp @f
no_tab2:
            
            invoke DrawText, [ebx].hdc, ADDR szBuff, TextItemLen,ADDR RctText, DT_VCENTER + DT_SINGLELINE + DT_CENTER + DT_NOCLIP
@@:        
            add RctText.right, 4        ;  ,      
        .endif  
    
    .elseif eax == MFT_SEPARATOR           ;   SEPARATOR
    
        invoke FillRect, [ebx].hdc, ADDR [ebx].rcItem, hBrushBorder        
        invoke CopyRect, ADDR RctBorder, ADDR [ebx].rcItem
        mov eax, WidthBorder
        add RctBorder.left, eax                     
        invoke FillRect, [ebx].hdc, ADDR RctBorder, hBrushRight
        
        ; Draw the seperator
         
        invoke CopyRect, ADDR RctSep, ADDR [ebx].rcItem
        mov eax, WidthBorder        
        add RctSep.left, eax
        add RctSep.left, 5          ; 5 -      
        mov eax, RctSep.bottom
        sub eax, RctSep.top
        shr eax, 1
        add RctSep.top, eax
        m2m RctSep.bottom, RctSep.top
        dec RctSep.top
        ;inc RctSep.bottom            
        invoke FillRect, [ebx].hdc, ADDR RctSep, hBrushSep
    
    .elseif eax == MFT_BITMAP              ;   BITMAP
    
    
    
    .endif

    invoke DeleteObject, hBrushSel
    invoke DeleteObject, hBrushSelBor
    invoke DeleteObject, hBrushSep      ;        CheckItema
    invoke DeleteObject, hBrushRight    ;    ,    .
    invoke DeleteObject, hBrushBorder
    invoke DeleteObject, hBrushUpItem

assume ebx: nothing        
   ret
DrawItemXP endp

; #########################################################################
;                                                                         ;
;        XP                      ;                           ;
;                                                                         ;
; #########################################################################

DrawCheck_XP proc uses ebx hDC:HDC, lpRect:DWORD, State:BYTE, CheckMark:BYTE

LOCAL RctCheck              :RECT
LOCAL hPen                  :HPEN
LOCAL hBrush                :HBRUSH    ;   CheckItema
LOCAL OldPen                :HPEN      ;     
LOCAL OldBrush              :HBRUSH
LOCAL hGlyphFont            :HFONT
LOCAL OldFont               :HFONT     ;    
LOCAL colorSel              :COLORREF
LOCAL colorBorder           :COLORREF
LOCAL GlyphArray[2]         :BYTE
LOCAL ncinfo                :NONCLIENTMETRICS

    mov colorBorder, $invoke ( GetSysColor, COLOR_HIGHLIGHT )
    call GetXpHighlightColor
    mov colorSel, eax
    
   ;     CheckItema.   
   
    mov ncinfo.cbSize, sizeof(NONCLIENTMETRICS)           ;   
    invoke SystemParametersInfo,SPI_GETNONCLIENTMETRICS,\
                              sizeof(NONCLIENTMETRICS),\
                              addr ncinfo, 0                                      ;  ,    
    
 
    .if ncinfo.lfMenuFont.lfHeight > -15
        mov ncinfo.lfMenuFont.lfHeight, -15
    .endif

;   mov ncinfo.lfMenuFont.lfWidth, 14
    
    mov ncinfo.lfMenuFont.lfCharSet, DEFAULT_CHARSET
    
    invoke memfill, ADDR ncinfo.lfMenuFont.lfFaceName, LF_FACESIZE, 0
    invoke szCopy, ADDR szGlyphFont, ADDR ncinfo.lfMenuFont.lfFaceName                             
    invoke CreateFontIndirect,  ADDR ncinfo.lfMenuFont
       
    mov hGlyphFont, eax             ;   

    mov ebx, lpRect

    mov eax, [ebx].RECT.left        ;   
    add eax, 2
    mov RctCheck.left, eax
    mov eax, [ebx].RECT.top
    add eax, 2 
    mov RctCheck.top, eax
    mov eax, [ebx].RECT.left
    add eax, WidthBorder
    sub eax, 2                      ;   ,  MEASUREITEM      
    mov RctCheck.right, eax
    mov eax, [ebx].RECT.bottom
    sub eax, 2
    mov RctCheck.bottom, eax

;--------------      ------------------
    
    xor eax, eax                    ;  
    mov al, State 
    and al, GRAY or SELECT or UNSELECT

    .if al == GRAY    
    
        ;        CheckItema 
    
        invoke LightenColor, 128, $invoke ( GetSysColor, COLOR_GRAYTEXT )
        invoke CreateSolidBrush, eax
        mov hBrush, eax  

    
        invoke DarkenColor, 8, $invoke ( GetSysColor, COLOR_GRAYTEXT )
        invoke CreatePen,PS_SOLID,1,eax
        mov hPen, eax
        
    .elseif al == SELECT

        ;       CheckItema   

        invoke MixedColor, colorSel, colorBorder
        invoke CreateSolidBrush, eax
        mov hBrush, eax

        invoke MixedColor, colorSel, colorBorder
        invoke DarkenColor, 128, eax
        invoke CreatePen,PS_SOLID,1,eax
        mov hPen, eax
     
    .elseif al == UNSELECT

        ;     CheckItema   .
    
        invoke MixedColor, colorSel, colorBorder
        invoke LightenColor, 128, eax
        invoke CreateSolidBrush, eax
        mov hBrush, eax
        
        invoke MixedColor, colorSel, colorBorder
        invoke DarkenColor, 128, eax


        invoke CreatePen,PS_SOLID,1,eax
        mov hPen, eax
    
    .endif

;--------------  CheckItema----------------------------------------

    mov OldPen, $invoke ( SelectObject, hDC, hPen )
    mov OldBrush, $invoke ( SelectObject, hDC, hBrush )

    invoke Rectangle,hDC,RctCheck.left,RctCheck.top,
                     RctCheck.right,RctCheck.bottom

    invoke SelectObject, hDC, OldPen
    invoke SelectObject, hDC, OldBrush
    invoke DeleteObject, hBrush
    invoke DeleteObject, hPen
    
;-------------- -------------------------------------------------
    
    invoke SetBkMode,hDC,TRANSPARENT
    invoke SelectObject, hDC, hGlyphFont
    mov OldFont, eax
    
;    add RctCheck.top, 2    
;    sub RctCheck.bottom, 1
;    add RctCheck.left, 2
;    sub RctCheck.right, 2
    
    .if CheckMark               
        mov GlyphArray, 69h         ; Bullet
    .else
        add RctCheck.top, 1  
        mov GlyphArray, 62h         ; Checkmark
    .endif 
                               
    invoke DrawText, hDC,ADDR GlyphArray, 1, ADDR RctCheck, DT_CENTER or DT_VCENTER or DT_SINGLELINE   
    
    invoke SelectObject, hDC, OldFont   ;       
    invoke DeleteObject, hGlyphFont
    
    ret
DrawCheck_XP endp