    .486
    .model flat, stdcall
    option casemap :none

;     include files
;     ~~~~~~~~~~~~~
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\gdi32.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc
    include \masm32\include\comctl32.inc
    include \masm32\include\debug.inc
      
;     libraries
;     ~~~~~~~~~
    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\gdi32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\comctl32.lib      
    includelib \masm32\lib\debug.lib

;macros 
    include   \masm32\macros\macros.asm

$invoke MACRO Fun:REQ, A:VARARG
  IFB <A>
    invoke Fun
  ELSE
    invoke Fun, A
  ENDIF
  EXITM <eax>
        ENDM       


GetRValue MACRO arg:REQ
	mov eax, arg
	and eax, 0ffh
endm <eax>

GetGValue MACRO arg:REQ
	mov eax, arg
	shr eax, 8
	and eax, 0ffh
endm <eax>

GetBValue MACRO arg:REQ
	mov eax, arg
	shr eax, 16
endm <eax>

LOWORD macro bigword    ;     
   mov  eax,bigword
   and  eax,0FFFFh     ;; Set to low word 
endm


HIWORD macro bigword    ;    
   mov  eax,bigword
   shr  eax,16         ;; Get high word
endm

MENUINFO STRUCT
    cbSize          DWORD ?
    fMask           DWORD ?
    dwStyle         DWORD ?
    cyMax           UINT  ?
    hbrBack         HBRUSH ?
    dwContextHelpID DWORD ?
    dwMenuData      DWORD ?    
MENUINFO ENDS         

    include XXMenu.inc

WndProc_Menu        PROTO   :DWORD,:DWORD,:DWORD,:DWORD
SubMenuToOwnerdraw  PROTO   :HMENU
MainMenuToOwnerdraw PROTO   :HMENU
UpItemOwnDrToNormal PROTO   :HMENU
MeasureItem         PROTO   :LPARAM
DrawItem            PROTO   :LPARAM
OdaDrawentireXP     PROTO   :LPARAM
OdaSelectXP         PROTO   :LPARAM
OdaDrawentire_2000  PROTO   :LPARAM
OdaSelect_2000      PROTO   :LPARAM
OdaDrawentire_Default_Ico   PROTO   :LPARAM
OdaSelect_Default_Ico       PROTO   :LPARAM
DrawString          PROTO   :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
DrawIcn             PROTO   :DWORD, :DWORD, :DWORD, :BYTE
DrawBmp             PROTO   :DWORD, :DWORD, :DWORD, :BYTE
SetMenuItemIcon     PROTO   :DWORD, :HICON
CreateColorBrush    PROTO   :DWORD
DarkenColor         PROTO   :DWORD, :COLORREF
GrayColor           PROTO   :COLORREF
MixedColor          PROTO   :COLORREF, :COLORREF
LightenColor        PROTO   :DWORD, :COLORREF
MidColor            PROTO   :COLORREF, :COLORREF
DrawCheck_XP        PROTO   :HDC, :DWORD, :BYTE, :BYTE
DrawCheck_2000      PROTO   :HDC, :DWORD, :BYTE, :BYTE
SubMenuToStyle      PROTO   :HMENU, :DWORD
MenuToStyle         PROTO   :HMENU, :DWORD
ChangeStyle         PROTO   :HMENU, :DWORD
SubMenuToNormal     PROTO   :HMENU
OwnerDrawToNormal   PROTO   :HMENU
SetNewWndProc       PROTO   :HWND
SetOldWndProc       PROTO   :HWND
IsID_ThemeXP_inc	PROTO   :HWND, :HMENU
IsID_ThemeXP_dec	PROTO   :HWND, :HMENU

HookProc            PROTO   :DWORD,:DWORD, :DWORD
OnDrawBorder        PROTO   :HWND, :HDC
OnDrawShade         PROTO   :HWND, :HDC
OnEraseBkgnd        PROTO   :HWND, :HDC
UnSubClassMenu      PROTO   :HWND
WndProc_WindowMenu  PROTO   :DWORD, :DWORD, :DWORD, :DWORD

DrawShade           PROTO   :HDC,:DWORD,:BYTE,:BYTE,:BYTE,:BYTE




.data
szGlyphFont         db      "Marlett",0
szProp_XX           db      "OLD_WND_PROC",0
szProp_NC           db      "NC_PAINT",0
ClassWndMenu        db      "#32768",0
fSelection          BYTE    TRUE            ;  true    
;fAccel              BYTE    TRUE

.data?
hMenu               HMENU   ?
hHook               HHOOK   ?

WidthBorder         dd      ?
HeightBorder        dd      ?

XCor                DWORD   ?
YCor                DWORD   ?

; 
fPopup              BYTE    ?

;fPopup              BYTE    ?
no_nc_paint         BYTE    ?

.const

GRAY        equ 1
SELECT      equ 2
UNSELECT    equ 3

WIN_XP      equ 1
WIN_98      equ 2
WIN_ME      equ 3
WIN_2000    equ 4
 
DARK_UP    equ 1
DARK_DOWN  equ 2
DARK_LEFT  equ 1
DARK_RIGHT equ 2

DARK_NONE  equ 0

SPI_GETDROPSHADOW equ 1024h
   
.code

;===========================================================================;
; Name:     DllEntry                                                        ;
; Function: Performs an undo action (if any)                                ;
;                                                                           ;
; Params:   lpEditData = Address of the RS Edit control's data structure    ;
;                                                                           ;
; Returns:  Nothing                                                         ;
;===========================================================================;

DllEntry proc hInstance:HINSTANCE, reason:DWORD, reserved1:DWORD

    .if reason==DLL_PROCESS_ATTACH                 ; DLL 
                 
    .elseif reason==DLL_PROCESS_DETACH             ; DLL 

 
    .elseif reason==DLL_THREAD_ATTACH

    .else        ; DLL_THREAD_DETACH

    .endif
    mov  eax,1
    ret
DllEntry endp

; #########################################################################
;                                                                         ;
;                         ;
;                                                                         ;
; #########################################################################    

WndProc_Menu proc hWin:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

LOCAL OldhMenu  :HMENU
LOCAL OldWndProc :DWORD

    invoke GetProp, hWin, ADDR szProp_XX
    mov OldWndProc, eax

    .if uMsg == WM_INITMENUPOPUP    
            
;          PrintDec wParam, "WM_INITMENUPOPUP"

        ; !!!  !!!
        ;   RedrawMenu    WM_INITMENUPOPUP
        ;    .


        ;     , 
        ; ..   , RedrawMenu  WM_INITMENUPOPUP        ; 

        invoke CallWindowProc,OldWndProc,hWin,uMsg,wParam,lParam    ; d_c
                     
          .if !hMenu ;&& !fAccel
          
                m2m hMenu, wParam             
                mov fPopup, TRUE    
                        
            invoke GetStyleMenu, hMenu  ;      
            push eax         
            .if eax == STYLE_OFFICE_XP
                call UnInstallHook
                call InstallHook                        
            .endif
            pop eax
            .if eax == STYLE_OFFICE_XP || eax == STYLE_OFFICE_2000
                invoke SubMenuToOwnerdraw, hMenu       ;      OWNERDRAW            
            .endif
             
            HIWORD lParam   ;  ?
            .if eax              
                invoke IsID_ThemeXP_inc, hWin, hMenu  ; Special purpose for windows XP with themes!!!
            .endif
                
          .endif    
          
;        jmp  d_c           |?| - |?|

    .elseif uMsg == WM_UNINITMENUPOPUP
       
;       PrintDec wParam, "WM_UNINITMENUPOPUP"       
        
          mov eax, wParam
          .if hMenu == eax ;&& !fAccel
    
            invoke GetStyleMenu, eax          
             .if eax == STYLE_OFFICE_XP ;              
                call UnInstallHook      
             .endif           
            mov hMenu, 0
            
            HIWORD lParam
            .if eax == MF_SYSMENU               
                invoke IsID_ThemeXP_dec, hWin, wParam  ; Special purpose for windows XP with themes!!!
            .endif             
          .endif
                
        jmp  d_c
        
    .elseif uMsg == WM_MEASUREITEM
    
     .if !wParam    ; MENU? (wParam == 0 - only menu)     

        m2m OldhMenu, hMenu             ;     ,     "WM_UNINITMENUPOPUP"

        .if !hMenu                      ;         (main - popup)
            invoke GetMenu, hWin
            mov hMenu, eax
            mov fPopup, FALSE
        .else
            mov fPopup, TRUE    
        .endif
        
        invoke IsMenu, hMenu            ;   ,  
        .if !eax                
            jmp no_measure
        .endif
                   
        invoke MeasureItem, lParam
        
no_measure:
        m2m hMenu, OldhMenu
        mov fPopup, TRUE        
                
     .endif
     
     jmp  d_c           
 
    .elseif uMsg == WM_DRAWITEM
    
     .if !wParam    ; MENU? (wParam == 0 - only menu)     
   
        m2m OldhMenu, hMenu         ;     ,     "WM_UNINITMENUPOPUP"
   
        .if !hMenu                  ;         (main - popup)
@@:
            invoke GetMenu, hWin
            mov hMenu, eax
            mov fPopup, FALSE
        .else
        
;            .if fAccel
;                jmp @b
;            .else
                 mov fPopup, TRUE
;            .endif
                        
        .endif
        
        invoke IsMenu, hMenu        ;   ,  
        .if !eax                
            jmp no_drawitem
        .endif   
   
        invoke DrawItem, lParam
        
no_drawitem:

        m2m hMenu, OldhMenu
        mov fPopup, TRUE     
        
        .endif     
             
     jmp  d_c

;    .elseif uMsg == WM_ENTERMENULOOP
;    
;;        PrintDec wParam, "WM_ENTERMENULOOP"
;        mov fAccel, FALSE
;        jmp  d_c     
;
;    .elseif uMsg == WM_EXITMENULOOP
;    
;;        PrintDec wParam, "WM_EXITMENULOOP"
;        mov fAccel, TRUE
;        jmp  d_c 


;    .elseif uMsg == WM_SYSCOLORCHANGE
;
;        PrintDec wParam, "WM_SYSCOLORCHANGE"
        
    .elseif uMsg == WM_DESTROY
        invoke RemoveProp, hWin, ADDR szProp_XX        
        invoke SetWindowLong, hWin, GWL_WNDPROC, OldWndProc        
        call UnInstallHook
        jmp  d_c
    .else

d_c:        
        invoke CallWindowProc,OldWndProc,hWin,uMsg,wParam,lParam
        ret
    .endif           
 
    xor eax,eax
    ret
WndProc_Menu endp

; #########################################################################
;                                                                         ;
;     ( ),  .          ;
;                                                                         ;
; #########################################################################

SetStyleMenu proc h_Menu :HMENU, dwStyle :DWORD

    invoke ChangeStyle, h_Menu, dwStyle

    ret
SetStyleMenu endp

; #########################################################################
;                                                                         ;
;     ( ),  .          ;
;                                                                         ;
; #########################################################################

ChangeStyle proc  h_Menu :HMENU, dwStyle :DWORD

LOCAL nHightItemCount :DWORD
LOCAL nCount          :DWORD
LOCAL hSubMenu        :HMENU    

    invoke MenuToStyle, h_Menu, dwStyle 
    mov nHightItemCount, $invoke (GetMenuItemCount, h_Menu)
    
    mov nCount, 0

@@: 
    mov hSubMenu, $invoke (GetSubMenu, h_Menu, nCount)
    
    .if hSubMenu
        invoke SubMenuToStyle, hSubMenu, dwStyle
    .endif
    
    inc nCount  
    
    mov eax, nCount
    cmp eax, nHightItemCount    
    jb  @b
    
e_t:    
    ret
ChangeStyle endp

; #########################################################################
;                                                                         ;
;     ,          ;
;        ()                ;
;                                                                         ;
; #########################################################################

SubMenuToStyle proc hSubMenu:HMENU, dwStyle :DWORD

    LOCAL nPos        :DWORD
    LOCAL LastItemID  :UINT
    LOCAL mii         :MENUITEMINFO

    invoke MenuToStyle, hSubMenu, dwStyle

    mov nPos, 0
    mov mii.cbSize, sizeof (MENUITEMINFO)
    mov mii.fMask, MIIM_ID or MIIM_SUBMENU
    jmp s_t

@@: 
    m2m LastItemID, mii.wID
    inc nPos

s_t:   
    invoke GetMenuItemInfo, hSubMenu, nPos, TRUE, ADDR mii
    
    mov eax, LastItemID
    
    cmp eax, mii.wID
    je @f

    .if mii.hSubMenu
    
        invoke SubMenuToStyle, mii.hSubMenu, dwStyle 
    
    .endif

    jmp @b  
    
@@:
    ret
SubMenuToStyle endp

; #########################################################################
;                                                                         ;
;     .                                    ;
;   .                                            ;  
;                                                                         ;
; #########################################################################

MenuToStyle proc h_Menu :HMENU, dwStyle :DWORD
 
LOCAL mi    :MENUINFO    

    invoke GetStyleMenu, h_Menu
    cmp eax, dwStyle
    je  e_t
    
    push eax                                ;   
    mov mi.cbSize, sizeof (MENUINFO)
    mov mi.fMask, MIM_MENUDATA
    m2m mi.dwMenuData, dwStyle
    invoke SetMenuInfo, h_Menu, ADDR mi
    pop eax

e_t:    
    ret
MenuToStyle endp

; #########################################################################
;                                                                         ;
;    WM_MEASUREITEM.                           ;
;                                                                         ;
; #########################################################################

MeasureItem proc uses ebx lParam:LPARAM

    LOCAL mii         :MENUITEMINFO
    LOCAL mi          :MENUINFO
    LOCAL ddbinfo     :BITMAP
    LOCAL szBuff[128] :BYTE
    LOCAL hDC         :HDC
    LOCAL StrSize     :SIZEL
    LOCAl TextItemLen :DWORD
    LOCAL ncinfo      :NONCLIENTMETRICS
    LOCAL hfontMenu   :HFONT

    mov ebx, lParam
    assume ebx: ptr MEASUREITEMSTRUCT
        
       .if [ebx].CtlType == ODT_MENU

                mov mii.cbSize, SIZEOF mii
                mov mii.fMask, MIIM_TYPE or MIIM_DATA or MIIM_STATE
                invoke GetMenuItemInfo,hMenu,[ebx].itemID,FALSE,ADDR mii        
                
                mov eax, mii.fType
                and eax, MFT_SEPARATOR or MFT_STRING or MFT_BITMAP
                
                .if eax == MFT_SEPARATOR
                
                .if fPopup  ; popup
                    mov [ebx].itemHeight, 8
                    mov [ebx].itemWidth, 8
                    
;                    mov WidthBorder, 
                                    
                .else       ; main                
                    mov [ebx].itemHeight, 8
                    mov [ebx].itemWidth, 8                     
                .endif
                    
                .elseif eax == MFT_STRING || [ebx].itemID
                
                    invoke GetMenuString, hMenu, [ebx].itemID, ADDR szBuff, 128, MF_BYCOMMAND
                    mov TextItemLen, eax    
                    mov hDC, $invoke ( GetDC, NULL )
                    
                    
                    mov ncinfo.cbSize, sizeof(NONCLIENTMETRICS)           ;   
                    invoke SystemParametersInfo,SPI_GETNONCLIENTMETRICS,\
                                sizeof(NONCLIENTMETRICS),\
                                addr ncinfo, 0                                      ;  ,    
                                
                    .if eax
                        invoke CreateFontIndirect,  ADDR ncinfo.lfMenuFont         ;  
                        mov   hfontMenu, eax                                       ;                           
                    .else
                        invoke GetStockObject, DEFAULT_GUI_FONT
                    .endif                    
                    
                    invoke SelectObject, hDC, eax
                    push eax
                    
                    invoke GetTextExtentPoint32, hDC, ADDR szBuff, TextItemLen, ADDR StrSize
                    
                    push hDC
                    call SelectObject               ;  
                    invoke DeleteObject, hfontMenu                     
                    
                    invoke ReleaseDC, NULL, hDC


                    .if fPopup  ; popup
                         
                            ;    
                         
                            mov eax, StrSize.y
                            add eax, 7+2          ;  +  
                            add eax, 5            ;                  
                            add StrSize.x, eax    ;     
                                        
                        ; Special case for system menu
                        
                        .if [ebx].itemID >= SC_SIZE && [ebx].itemID <= SC_HOTKEY
                            add StrSize.x, 35
                        .endif
                       
                    .else       ; main                    
                     
                        .if mii.fState & MFS_CHECKED
                            mov eax, StrSize.y
                            add eax, 7+2          ;  +                                 
                            add StrSize.x, eax    ;    
                            
                        .elseif mii.dwItemData   
                            ; |      |
                            mov eax, StrSize.y
                            add eax, 7+2          ;  +                   
                            add StrSize.x, eax    ;    
                        .endif
                                            
                        add StrSize.x, 2            ;    
                    
                    .endif
                    
                    ; !!!     TAB   
                    
                    cld                         ;    
                    lea edi, szBuff             ;  
                    mov al, 09h                 ;  
                    mov ecx, TextItemLen        ;  
                    repne scasb                 ;   '\t'  
                    jne no_tab                  ;  '\t'    
                    mov eax, WidthBorder
                    shr eax, 1
                    add eax, 5                  ;  
                    add StrSize.x, eax          ;        Tab
no_tab:             
                    m2m [ebx].itemWidth, StrSize.x  ;  
                    mov eax, StrSize.y              
                    add eax, 7                                        
                    mov [ebx].itemHeight, eax       ;  
                        
                    mov HeightBorder, eax
                    add eax, 2                  ;   
                    mov WidthBorder, eax    
                                   
                .elseif eax == MFT_BITMAP
                
                    ; retrieve DDB information
                    invoke GetObject, mii.dwTypeData, sizeof(BITMAP), ADDR ddbinfo                
                    m2m [ebx].itemWidth, ddbinfo.bmWidth
                    m2m [ebx].itemHeight, ddbinfo.bmHeight
                
                .endif
                                
        .endif   

    assume ebx: nothing
    ret
MeasureItem endp

; #########################################################################
;                                                                         ;
;    WM_DRAWITEM.                              ;
;                                                                         ;
; #########################################################################

DrawItem proc uses ebx lParam:LPARAM

mov ebx, lParam
assume ebx: ptr DRAWITEMSTRUCT

    invoke IsMenu, hMenu
    .if !eax
        jmp e_t
    .endif

  .if [ebx].CtlType == ODT_MENU

    invoke SaveDC, [ebx].hdc
    invoke SetBkMode, [ebx].hdc, TRANSPARENT
    
    invoke GetStyleMenu, hMenu
    
    .if eax == STYLE_OFFICE_XP              ;   OFFICE XP
        call DrawItemXP ;, lParam           ;  
    .elseif eax == STYLE_OFFICE_2000        ;   OFFICE 2000    
        call DrawItem2000 ;, lParam         ;  
    .endif
    
    invoke RestoreDC, [ebx].hdc, -1  
  
  .endif  
    
e_t:

assume ebx: nothing
    mov eax,1
    ret
DrawItem endp

; #########################################################################
;                                                                         ;
;     .                                      ;                           ;
;                                                                         ;
; #########################################################################

DrawIcn proc uses ebx hDC:HDC, lpRect:DWORD, HIcon:HICON, uFlags:BYTE

    LOCAL RctIcon :RECT
    LOCAL xX :DWORD, yY :DWORD
    LOCAL MonoIcon :DWORD
    LOCAL iconinfo :ICONINFO
    LOCAL hMemDC :DWORD
    LOCAL hBrushShade:HBRUSH    ;      .
    LOCAL OldBrush   :HBRUSH    ;   
    LOCAL OldBmp     :HBITMAP
    LOCAL i_X        :DWORD
    LOCAL i_Y        :DWORD
    
    mov ebx, lpRect

;    RGB 100, 97, 92        ;    
    invoke GetSysColor, COLOR_GRAYTEXT
    mov hBrushShade, $invoke (CreateSolidBrush, eax)    
   
;       .
   
    mov eax, WidthBorder    
    sub eax, 16             ; !!!    ?
    invoke IntDiv, eax, 2    
    mov xX, eax             ;[[WidthHeight-16]/2]
    
    mov eax, HeightBorder    
    sub eax, 16
    invoke IntDiv, eax, 2
    mov yY, eax             ;[[WidthHeight-16]/2]
        
    xor eax, eax                    ;  
    mov al, uFlags 
    and al, GRAY or SELECT or UNSELECT
    
    .if al == UNSELECT

        inc yY    
        
    .elseif al == SELECT    
    
        inc yY      ;  UNSELECT,  

    ;    ,           
        mov eax, [ebx].RECT.left
        add eax, xX
        mov RctIcon.left, eax
        mov eax, [ebx].RECT.top
        add eax, yY
        mov RctIcon.top, eax
        
        sub xX, 2   ;    
        sub yY, 2

        mov hMemDC, $invoke (CreateCompatibleDC,hDC)
        invoke GetIconInfo,HIcon,ADDR iconinfo

;        invoke SetTextColor,hDC,Black
        invoke SetBkColor,hDC,White     
        mov OldBmp, $invoke ( SelectObject,hMemDC,iconinfo.hbmMask )
        mov OldBrush, $invoke ( SelectObject, hDC, hBrushShade )
        invoke BitBlt,hDC,RctIcon.left, RctIcon.top,16, 16,hMemDC,0, 0,0B8074Ah ; D^(S&(P^D)))
        invoke SelectObject, hDC, OldBrush
        invoke SelectObject, hMemDC, OldBmp
          
        invoke DeleteObject, iconinfo.hbmMask
        invoke DeleteObject, iconinfo.hbmColor        
        invoke DeleteDC, hMemDC
        
    .elseif al == GRAY                  

        inc xX

    ;           
        mov eax, [ebx].RECT.left
        add eax, xX
        mov RctIcon.left, eax
        mov eax, [ebx].RECT.top
        add eax, yY
        mov RctIcon.top, eax

        mov hMemDC, $invoke (CreateCompatibleDC,hDC)
        invoke GetIconInfo,HIcon,ADDR iconinfo

;        invoke SetTextColor,hDC,Black
        invoke SetBkColor,hDC,White     
        mov OldBmp, $invoke ( SelectObject,hMemDC,iconinfo.hbmMask )
        mov OldBrush, $invoke ( SelectObject,hDC,hBrushShade )
        invoke BitBlt,hDC,RctIcon.left, RctIcon.top,16, 16,hMemDC,0, 0,0B8074Ah ; D^(S&(P^D)))
        invoke SelectObject, hDC, OldBrush
        invoke SelectObject, hMemDC, OldBmp
        
        invoke DeleteObject, iconinfo.hbmMask
        invoke DeleteObject, iconinfo.hbmColor     
        invoke DeleteDC, hMemDC

        jmp @f ;    
        
    .endif  

        mov eax, [ebx].RECT.left
        add eax, xX
        mov RctIcon.left, eax
        mov eax, [ebx].RECT.top
        add eax, yY 
        mov RctIcon.top, eax

        invoke DrawIconEx, hDC, RctIcon.left, RctIcon.top, HIcon,16, 16, NULL, NULL, DI_NORMAL

@@:
        invoke DeleteObject, hBrushShade
   ret
DrawIcn endp

; #########################################################################
;                                                                         ;
;      (    );                           ;
;                                                                         ;
; #########################################################################

DrawBmp proc uses ebx hDC:HDC, lpRect:DWORD, hBmp:HBITMAP, uFlags:BYTE

    LOCAL RctBmp                :RECT
    LOCAL GlyphArray[2]         :BYTE
    LOCAL hGlyphFont            :HFONT
    LOCAL OldFont               :HFONT
    LOCAL OldClr                :COLORREF
    LOCAL ncinfo                :NONCLIENTMETRICS
   
        mov ebx, lpRect

        .if hBmp == HBMMENU_POPUP_MINIMIZE  
        
            mov GlyphArray, 30h          
        
        .elseif hBmp == HBMMENU_POPUP_MAXIMIZE
        
            mov GlyphArray, 31h
        
        .elseif hBmp == HBMMENU_POPUP_CLOSE
        
            mov GlyphArray, 72h
            
        .elseif hBmp == HBMMENU_POPUP_RESTORE
            
            mov GlyphArray, 32h
            
        .else        
        
            jmp exit_
        .endif

   ;     CheckItema.   
   
        mov ncinfo.cbSize, sizeof(NONCLIENTMETRICS)           ;   
        invoke SystemParametersInfo,SPI_GETNONCLIENTMETRICS,\
                                  sizeof(NONCLIENTMETRICS),\
                                  addr ncinfo, 0                                      ;  ,    
        
        
        .if ncinfo.lfMenuFont.lfHeight > -15
            mov ncinfo.lfMenuFont.lfHeight, -15
        .endif
        
        ;   mov ncinfo.lfMenuFont.lfWidth, 14
        
        mov ncinfo.lfMenuFont.lfCharSet, DEFAULT_CHARSET
        
        invoke memfill, ADDR ncinfo.lfMenuFont.lfFaceName, LF_FACESIZE, 0
        invoke szCopy, ADDR szGlyphFont, ADDR ncinfo.lfMenuFont.lfFaceName                             
        invoke CreateFontIndirect,  ADDR ncinfo.lfMenuFont
        mov hGlyphFont, eax

        invoke GetTextColor,hDC
        mov OldClr, eax

        invoke SetBkMode,hDC,TRANSPARENT
        invoke SelectObject, hDC, hGlyphFont
        mov OldFont, eax
        
        xor eax, eax                    ;  
        mov al, uFlags 
        and al, SELECT or UNSELECT
        
        .if al == GRAY

            invoke DarkenColor, 8, $invoke ( GetSysColor, COLOR_GRAYTEXT )   ; 
            invoke SetTextColor, hDC, eax
            mov OldClr, eax
            jmp @f
        
        .elseif al == UNSELECT
@@:
            mov eax, [ebx].RECT.left        ;   
            add eax, 2
            mov RctBmp.left, eax
            mov eax, [ebx].RECT.top
            add eax, 2
            mov RctBmp.top, eax
            mov eax, [ebx].RECT.left
            add eax, WidthBorder       
            mov RctBmp.right, eax
            mov eax, [ebx].RECT.bottom
            sub eax, 2  
            mov RctBmp.bottom, eax        
            
        .elseif al == SELECT

            invoke DarkenColor, 8, $invoke ( GetSysColor, COLOR_GRAYTEXT )   ; 
            invoke SetTextColor, hDC, eax
            mov OldClr, eax
             
            mov eax, [ebx].RECT.left        ;   
            add eax, 2
            mov RctBmp.left, eax
            mov eax, [ebx].RECT.top
            add eax, 2
            mov RctBmp.top, eax
            mov eax, [ebx].RECT.left
            add eax, WidthBorder       
            mov RctBmp.right, eax
            mov eax, [ebx].RECT.bottom
            sub eax, 2  
            mov RctBmp.bottom, eax                   
           
            invoke DrawText, hDC, ADDR GlyphArray, 1, ADDR RctBmp, DT_CENTER or DT_VCENTER
            
            mov eax, [ebx].RECT.left        ;   
            sub eax, 2
            mov RctBmp.left, eax
            mov eax, [ebx].RECT.top
            add eax, 1
            mov RctBmp.top, eax
            mov eax, [ebx].RECT.left
            add eax, WidthBorder       
            mov RctBmp.right, eax
            mov eax, [ebx].RECT.bottom
            sub eax, 1  
            mov RctBmp.bottom, eax
            invoke SetTextColor,hDC, OldClr
                                
        .endif
                      
        invoke DrawText, hDC, ADDR GlyphArray, 1, ADDR RctBmp, DT_CENTER or DT_VCENTER
        invoke SelectObject,hDC, OldFont           ;   
        invoke DeleteObject, hGlyphFont
        invoke SetTextColor,hDC, OldClr       
        
exit_:

        
    ret
DrawBmp endp

; #########################################################################
;                                                                         ;
;                                             ;  
;                                                                         ;
; #########################################################################

SetNewWndProc proc hWin :HWND

    ;      
    ;          
    invoke GetWindowLong, hWin, GWL_WNDPROC
    cmp eax, offset WndProc_Menu
    je e_t
     
    invoke SetWindowLong, hWin, GWL_WNDPROC, ADDR WndProc_Menu
    invoke SetProp, hWin, ADDR szProp_XX, eax

e_t:
    ret
SetNewWndProc endp

; #########################################################################
;                                                                         ;
;                                     ;  
;                                                                         ;
; #########################################################################

SetOldWndProc proc hWin :HWND

    ;      
    ;          
    invoke GetWindowLong, hWin, GWL_WNDPROC
    cmp eax, offset WndProc_Menu
    jne e_t
    
    invoke GetProp, hWin, ADDR szProp_XX 
    invoke SetWindowLong, hWin, GWL_WNDPROC, eax
    invoke RemoveProp, hWin, ADDR szProp_XX

e_t:
    ret
SetOldWndProc endp

; =========================================================================
;                  
;
; #########################################################################
;                                                                         ;
;       ,       ;  
;   OWNERDRAW     .                      ;
;                                                                         ;
; #########################################################################

PUBLIC RedrawMenu

RedrawMenu proc uses ebx hWin :HWND, h_Menu :HMENU, dwStyle :DWORD
    
    invoke IsWindow, hWin
    mov ebx, eax
    invoke IsMenu, h_Menu
    .if !ebx || !eax
        return FALSE
    .endif

    .if dwStyle == STYLE_DEFAULT
;        call UnInstallHook
        invoke SetOldWndProc, hWin
        invoke OwnerDrawToNormal, h_Menu    ;       OWNERDRAW
        je  @f
    .elseif dwStyle == STYLE_OFFICE_2000    
;        call UnInstallHook
        invoke UpItemOwnDrToNormal, h_Menu
        invoke MainMenuToOwnerdraw, h_Menu     ;      OWNERDRAW,    
    .elseif dwStyle == STYLE_OFFICE_XP
        ;invoke MainMenuToOwnerdraw, h_Menu     ;      OWNERDRAW,    
        invoke SubMenuToOwnerdraw, h_Menu      ;      OWNERDRAW
    .endif

    invoke SetNewWndProc, hWin    

@@:

    invoke SetStyleMenu, h_Menu, dwStyle    
    invoke GetMenu, hWin    
    .if eax == h_Menu
        invoke DrawMenuBar, hWin
    .endif
    
    mov eax, TRUE
    ret
RedrawMenu endp

; #########################################################################
;                                                                         ;
;      .                          ;  
;                                                                         ;
; #########################################################################

PUBLIC GetStyleMenu

GetStyleMenu proc h_Menu :HMENU

LOCAL mi    :MENUINFO 
    
    mov mi.cbSize, sizeof (MENUINFO)
    mov mi.fMask, MIM_MENUDATA    
    invoke GetMenuInfo, h_Menu, ADDR mi
    
    mov eax, mi.dwMenuData    
    
    ret
GetStyleMenu endp

; #########################################################################
;                                                                         ;
;      .                     ;
;                                                                         ;
; #########################################################################

PUBLIC SetMenuItemIcon

SetMenuItemIcon proc h_Menu:HMENU, ItemID:DWORD, hIcon:HICON

   LOCAL mii      :MENUITEMINFO
   
    mov mii.cbSize, sizeof (MENUITEMINFO)
    mov mii.fMask, MIIM_DATA   
    m2m mii.dwItemData, hIcon
    invoke SetMenuItemInfo, h_Menu, ItemID, FALSE, ADDR mii

    ret
SetMenuItemIcon endp

; #########################################################################
;                                                                         ;
;       .                     ;
;                                                                         ;
; #########################################################################

PUBLIC SetMenuIcon

SetMenuIcon proc h_Menu:HMENU, hImageList:HIMAGELIST, uNumButtons:DWORD, lpButtons:DWORD 

mov ebx, lpButtons

    .while uNumButtons
       
        invoke ImageList_GetIcon, hImageList, [ebx].MNUBUTTON.nIcon, ILD_NORMAL
        invoke SetMenuItemIcon, h_Menu, [ebx].MNUBUTTON.idItem, eax
        add ebx, sizeof (MNUBUTTON)
        dec uNumButtons

    .endw

	ret
SetMenuIcon endp

; #########################################################################
;                                                                         ;
;      .                     ;
;                                                                         ;
; #########################################################################

PUBLIC SetDisableSelect

SetDisableSelect proc uses edx bShow:BYTE

    xor eax, eax
    mov al, fSelection
    mov dl, bShow
    mov fSelection, dl

    ret
SetDisableSelect endp

include ToOwnerMenu.inc
include Color.inc
include Gradient.inc
include Office_xp.inc
include Office_2000.inc
include Hook.inc

end DllEntry