; #########################################################################
;                                                                         ;
;   WM_DRAWITEM -> itemAction =ODA_DRAWENTIRE ( XP);
;                                                                         ;
; #########################################################################

OdaDrawentire_Default_Ico PROC lParam:LPARAM

    LOCAL RctGray     :RECT, RctFill :RECT, RctCheck :RECT
    LOCAL mii         :MENUITEMINFO
    LOCAL p1          :POINT,p2   :POINT
    LOCAL OldFont     :HFONT
    LOCAl Len         :DWORD
    LOCAL szBuff[128] :BYTE
    LOCAL hIcon       :DWORD
    LOCAL hMemDC      :HDC
    LOCAL hBrushSel   :HBRUSH
    LOCAL hPenSel     :HPEN
    LOCAL hPenSep     :HPEN    ;        CheckItema
    
    LOCAL colorWindow :COLORREF
    LOCAL colorMenu   :COLORREF
    LOCAL colorMenuBar :COLORREF
    LOCAL colorBorder :COLORREF
    LOCAL colorBitmap :COLORREF
    LOCAL colorSel    :COLORREF
    LOCAL colorSep    :COLORREF

mov ebx, lParam    
assume ebx: ptr DRAWITEMSTRUCT

    ; ,   ..      

    mov colorBorder, $invoke ( GetSysColor, COLOR_HIGHLIGHT )
    mov colorMenuBar, $invoke ( GetSysColor, COLOR_MENU )
    mov colorWindow, $invoke ( GetSysColor, COLOR_WINDOW )
    mov colorBitmap, $invoke ( MixedColor, colorMenuBar, colorWindow )
    mov colorSep, $invoke ( GetSysColor, COLOR_GRAYTEXT )   
    call GetXpHighlightColor
    mov colorSel, eax

;         

    invoke MixedColor, colorSel, colorBorder
    invoke LightenColor, 64, eax
    invoke CreateSolidBrush, eax
    mov hBrushSel, eax

    invoke MixedColor, colorSel, colorBorder
    invoke DarkenColor, 128, eax
    invoke CreatePen,PS_SOLID,1,eax
    mov hPenSel, eax  
  
;  

    invoke DarkenColor, 8, colorSep
    invoke CreatePen,PS_SOLID,1,colorSep
    mov hPenSep, eax

;         
    mov mii.cbSize, SIZEOF mii
    mov mii.fMask, MIIM_DATA or MIIM_BITMAP or MIIM_FTYPE ;or MIIM_STRING
    invoke GetMenuItemInfo,hMenu,[ebx].itemID,FALSE,ADDR mii
    m2m hIcon, mii.dwItemData    

;     
    mov eax, mii.fType
    and eax, MFT_SEPARATOR or MFT_STRING or MFT_BITMAP
    
     .if eax == MFT_STRING                  ;   STRING

       invoke GetMenuString, hMenu, [ebx].itemID, ADDR szBuff, 128, MF_BYCOMMAND ;  
       mov Len, eax

       mov eax, [ebx].itemState 
       and eax, ODS_GRAYED

        .if eax
        
        mov eax, [ebx].itemState 
        and eax, ODS_CHECKED
        
        .if eax       
           
                invoke FillRect,[ebx].hdc,ADDR [ebx].rcItem,COLOR_MENU+1            
                
            .if Len  ; 
        
                invoke DrawString, [ebx].hdc, ADDR [ebx].rcItem, ADDR szBuff, Len, GRAY
                
            .endif            
        
                ;                 
                
                ;      
                
                mov eax, mii.fType
                and eax, MFT_RADIOCHECK
                .if eax == MFT_RADIOCHECK
                    mov al, TRUE
                .else
                    mov al, FALSE
                .endif
                invoke DrawCheck_XP, [ebx].hdc, ADDR [ebx].rcItem, GRAY, al
        
        .else
                invoke FillRect,[ebx].hdc,ADDR [ebx].rcItem,COLOR_MENU+1     
                
            .if hIcon    ;    
        
                invoke DrawIcn, [ebx].hdc, ADDR [ebx].rcItem, hIcon,GRAY
                
            .elseif mii.hbmpItem
                
                invoke DrawBmp, [ebx].hdc, ADDR [ebx].rcItem, mii.hbmpItem, GRAY
                
            .endif                
            
            .if Len  ; 
        
                invoke DrawString, [ebx].hdc, ADDR [ebx].rcItem, ADDR szBuff, Len,GRAY
                
            .endif
            
        .endif
        
        .else
        
        mov eax, [ebx].itemState 
        and eax, ODS_CHECKED
        
        .if eax
        
            mov eax, [ebx].itemState 
            and eax, ODS_SELECTED
            
            .if eax
        
                invoke SelectObject, [ebx].hdc, hPenSel
                invoke SelectObject, [ebx].hdc, hBrushSel
                invoke Rectangle,[ebx].hdc,[ebx].rcItem.left,[ebx].rcItem.top,
                                 [ebx].rcItem.right,[ebx].rcItem.bottom 
        
            .else               
        
                invoke FillRect,[ebx].hdc,ADDR [ebx].rcItem,COLOR_MENU+1        
            
            .endif        
        
                
            .if Len  ; 
                
                invoke DrawString, [ebx].hdc, ADDR [ebx].rcItem, ADDR szBuff, Len,0
                
            .endif
        
                ;      
                
                mov eax, mii.fType
                and eax, MFT_RADIOCHECK
                .if eax == MFT_RADIOCHECK
                    mov al, TRUE
                .else
                    mov al, FALSE
                .endif                                       
                invoke DrawCheck_XP, [ebx].hdc, ADDR [ebx].rcItem, UNSELECT, al
        .else
        
            mov eax, [ebx].itemState 
            and eax, ODS_SELECTED
            
            .if eax
                 
                invoke SelectObject, [ebx].hdc, hPenSel
                invoke SelectObject, [ebx].hdc, hBrushSel
                invoke Rectangle,[ebx].hdc,[ebx].rcItem.left,[ebx].rcItem.top,
                                 [ebx].rcItem.right,[ebx].rcItem.bottom 
        
            .else
        
                invoke FillRect,[ebx].hdc,ADDR [ebx].rcItem,COLOR_MENU+1
        
            .endif    
                
            .if hIcon    ;    
        
                invoke DrawIcn, [ebx].hdc, ADDR [ebx].rcItem, hIcon,UNSELECT
                
            .elseif mii.hbmpItem
                
                invoke DrawBmp, [ebx].hdc, ADDR [ebx].rcItem, mii.hbmpItem, UNSELECT
                
            .endif
            
            .if Len  ; 
                
                invoke DrawString, [ebx].hdc, ADDR [ebx].rcItem, ADDR szBuff, Len,0
                
            .endif          
        
        .endif
        
        .endif                      
                 
     .elseif eax == MFT_SEPARATOR           ;   SEPARATOR

        invoke FillRect,[ebx].hdc,ADDR [ebx].rcItem,COLOR_MENU+1   
        
        ; LINE GRAY
        mov eax, [ebx].rcItem.left
        add eax, WidthGray+5        ; 5 -      
        mov p1.x, eax
        mov eax, [ebx].rcItem.bottom
        sub eax, [ebx].rcItem.top
        shr eax, 1
        mov ecx, eax
        mov eax, [ebx].rcItem.top
        add eax, ecx
        mov p1.y, eax
        mov p2.y, eax
        m2m p2.x, [ebx].rcItem.right

        invoke SelectObject, [ebx].hdc, hPenSep
        invoke MoveToEx,[ebx].hdc,p1.x,p1.y,0
        invoke LineTo,[ebx].hdc,p2.x,p2.y
        
     .elseif eax == MFT_BITMAP              ;   BITMAP
     
                
    
     .endif
     
        invoke DeleteObject, hBrushSel
        invoke DeleteObject, hPenSel
        invoke DeleteObject, hPenSep       
        
    assume ebx: nothing
   ret
OdaDrawentire_Default_Ico endp

; #########################################################################
;                                                                         ;
;   WM_DRAWITEM -> itemAction = ODA_SELECT ( XP).  ;                           ;
;                                                                         ;
; #########################################################################

OdaSelect_Default_Ico proc uses ebx edx lParam:LPARAM

    LOCAL RctGray :RECT, RctFill :RECT, RctCheck :RECT
    LOCAL mii   :MENUITEMINFO
    LOCAl Len         :DWORD
    LOCAL szBuff[128] :BYTE
    LOCAL hIcon       :DWORD
    LOCAL hBrushSel   :HBRUSH
    LOCAL hPenSel     :HPEN
    LOCAL colorWindow :COLORREF
    LOCAL colorMenu   :COLORREF
    LOCAL colorMenuBar:COLORREF
    LOCAL colorBorder :COLORREF
    LOCAL colorBitmap :COLORREF
    LOCAL colorSel    :COLORREF
    LOCAL colorSep    :COLORREF
    
mov ebx, lParam
    
assume ebx: ptr DRAWITEMSTRUCT
 
; ,   ..      

    mov colorBorder, $invoke ( GetSysColor, COLOR_HIGHLIGHT )
    mov colorMenuBar, $invoke ( GetSysColor, COLOR_MENU )
    mov colorWindow, $invoke ( GetSysColor, COLOR_WINDOW )
    mov colorBitmap, $invoke ( MixedColor, colorMenuBar, colorWindow )
    call GetXpHighlightColor
    mov colorSel, eax

;         

    invoke MixedColor, colorSel, colorBorder
    invoke LightenColor, 64, eax
    invoke CreateSolidBrush, eax
    mov hBrushSel, eax

    invoke MixedColor, colorSel, colorBorder
    invoke DarkenColor, 128, eax
    invoke CreatePen,PS_SOLID,1,eax
    mov hPenSel, eax
    
; =============================================================       
    mov mii.cbSize, SIZEOF mii
    mov mii.fMask, MIIM_DATA or MIIM_BITMAP or MIIM_FTYPE
    invoke GetMenuItemInfo, hMenu, [ebx].itemID, FALSE, ADDR mii
    m2m hIcon, mii.dwItemData
    
    mov eax, mii.fType
    and eax, MFT_SEPARATOR or MFT_STRING or MFT_BITMAP
    
     .if eax == MFT_STRING                  ;   STRING

       invoke GetMenuString, hMenu, [ebx].itemID, ADDR szBuff, 128, MF_BYCOMMAND
       mov Len, eax

       mov eax, [ebx].itemState 
       and eax, ODS_SELECTED

       .if eax          ; PRESSED - SELECT

            mov eax, [ebx].itemState 
            and eax, ODS_GRAYED

            .if eax         
        
               mov eax, [ebx].itemState 
               and eax, ODS_CHECKED
       
                .if eax     

;                    .if Len  ; 
;                    
;                        invoke DrawString, [ebx].hdc, ADDR [ebx].rcItem, ADDR szBuff, Len, GRAY
;                        
;                    .endif
;                    
;                   ;                
;       
;                     invoke DrawCheck_XP, [ebx].hdc, ADDR [ebx].rcItem, GRAY ;( ,  ?)                
                
                .else
              
                    .if hIcon    ;  
                      
                        invoke DrawIcn, [ebx].hdc, ADDR [ebx].rcItem, hIcon,GRAY
                        
                    .elseif mii.hbmpItem
                
                        invoke DrawBmp, [ebx].hdc, ADDR [ebx].rcItem, mii.hbmpItem, GRAY
                
                    .endif                                               
                        
                    .if Len      ; 
                    
                        invoke DrawString, [ebx].hdc, ADDR [ebx].rcItem, ADDR szBuff, Len, GRAY
                        
                    .endif
                
                .endif            
              
            .else

               mov eax, [ebx].itemState 
               and eax, ODS_CHECKED
       
                .if eax

                    invoke SelectObject, [ebx].hdc, hPenSel
                    invoke SelectObject, [ebx].hdc, hBrushSel
                    invoke Rectangle,[ebx].hdc,[ebx].rcItem.left,[ebx].rcItem.top,
                                     [ebx].rcItem.right,[ebx].rcItem.bottom                 
            
                    .if Len  ; 
                        
                        invoke DrawString, [ebx].hdc, ADDR [ebx].rcItem, ADDR szBuff, Len, 0
                        
                    .endif
                    
                    ;                
        
                    mov eax, mii.fType
                    and eax, MFT_RADIOCHECK
                    .if eax == MFT_RADIOCHECK
                        mov al, TRUE
                    .else
                        mov al, FALSE
                    .endif
                    invoke DrawCheck_XP, [ebx].hdc, ADDR [ebx].rcItem, SELECT, al               
                
                .else

                    invoke SelectObject, [ebx].hdc, hPenSel
                    invoke SelectObject, [ebx].hdc, hBrushSel
                    invoke Rectangle,[ebx].hdc,[ebx].rcItem.left,[ebx].rcItem.top,
                                     [ebx].rcItem.right,[ebx].rcItem.bottom
                    
                    .if hIcon    ;    
                
                        invoke DrawIcn, [ebx].hdc, ADDR [ebx].rcItem, hIcon, SELECT
                        
                    .elseif mii.hbmpItem
                
                        invoke DrawBmp, [ebx].hdc, ADDR [ebx].rcItem, mii.hbmpItem, SELECT
                
                    .endif                        
                       
                    .if Len  ; 
                        
                        invoke DrawString, [ebx].hdc, ADDR [ebx].rcItem, ADDR szBuff, Len, 0
                        
                    .endif                  
                
                .endif
        
            .endif      
        
       .else            ; UNSELECT

            mov eax, [ebx].itemState 
            and eax, ODS_GRAYED
            
            .if eax
 
                .if hIcon    ;    
            
                    invoke DrawIcn, [ebx].hdc, ADDR [ebx].rcItem, hIcon, GRAY
                    
                .endif
                
                .if Len  ; 

                    invoke DrawString, [ebx].hdc, ADDR [ebx].rcItem, ADDR szBuff, Len, GRAY
                    
                .endif              
            
            .else

               mov eax, [ebx].itemState 
               and eax, ODS_CHECKED
       
                .if eax
                        invoke FillRect,[ebx].hdc,ADDR [ebx].rcItem,COLOR_MENU+1
                    
                    .if Len  ; 
                        
                        invoke DrawString, [ebx].hdc, ADDR [ebx].rcItem, ADDR szBuff, Len, 0
                        
                    .endif
                    
                        mov eax, mii.fType
                        and eax, MFT_RADIOCHECK
                        .if eax == MFT_RADIOCHECK
                            mov al, TRUE
                        .else
                            mov al, FALSE
                        .endif
                        invoke DrawCheck_XP, [ebx].hdc, ADDR [ebx].rcItem, UNSELECT, al                   
                
                .else
                        invoke FillRect,[ebx].hdc,ADDR [ebx].rcItem,COLOR_MENU+1
                    
                    .if hIcon    ;    
                
                        invoke DrawIcn, [ebx].hdc, ADDR [ebx].rcItem, hIcon, UNSELECT
                        
                    .elseif mii.hbmpItem
                
                        invoke DrawBmp, [ebx].hdc, ADDR [ebx].rcItem, mii.hbmpItem, UNSELECT
                
                    .endif
                    
                    .if Len      ; 
                        
                        invoke DrawString, [ebx].hdc, ADDR [ebx].rcItem, ADDR szBuff, Len, 0
                        
                    .endif                  
                
                .endif
    
            .endif      
                
       .endif
       
     .elseif eax == MFT_BITMAP              ;   BITMAP
         
         
                  
     .endif

    invoke DeleteObject, hBrushSel
    invoke DeleteObject, hPenSel   
    
    assume ebx: nothing

   ret
OdaSelect_Default_Ico endp